// dll.cpp : Defines the exported functions for the DLL application.
//
#include "stdafx.h"
#include "DSMPESER4M.h"
int return_value=0;

int DSCUDAPICALL DSE_MPE_SER4M_INIT()
{
	#ifdef WIN32
	if((return_value=Find_first_EXAR_port())==-1)
	{
		printf("Driver is not installed\n");
		return -1;
	}
	wsprintf(port_name, L"\\\\.\\COM%d", COM[0]);
	if ((hPortHandle = CreateFile( port_name,  GENERIC_READ | GENERIC_WRITE, FILE_SHARE_WRITE,  NULL,  OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL  	)) == ((HANDLE)-1))
	{
		printf("Cannot open the file handle\n");
		return -1; 
	}
	#endif

	#ifdef LINUX

	if ( iopl(3) ) 
	{
		if ( getuid() != 0 ) 
		{
			printf( "You must run this application as root\n");
			return -1;
		}
	}
	
	fd=open("/dev/ttyXR0", O_RDWR);
	if(fd <0)
	{
         printf("\Driver is not installed \n");
	     return -1;
	}
	#endif
	return 0;

}
int  DSCUDAPICALL DSE_MPE_SER4M_READ(BYTE bReg,BYTE *pbValue)
{
	#ifdef WIN32
	BOOL Status;
	DWORD cbReturned;
	
	Status = DeviceIoControl( hPortHandle,IOCTL_XRPORT_READ_CONFIG_REG,&bReg,sizeof(BYTE),pbValue,sizeof(BYTE),&cbReturned,0);
	if (!Status)
	{ 
		printf("Error in Reading...!", "Error", MB_OK|MB_ICONERROR); 
		return -1;
	}
	#endif

	#ifdef LINUX
	input.reg = bReg;
	error=ioctl(fd, EXAR_READ_REG, &input);
	if(error <0)
	{
	    printf("Error: Driver Read call Failed. Press Enter to continue:");

		if(getchar() == '\n')
			return -1;
	}
	*pbValue = input.regvalue ;
	#endif
	return 0;
}

int DSCUDAPICALL DSE_MPE_SER4M_WRITE(BYTE bReg,BYTE bValue)
{
	#ifdef WIN32
	BOOL Status;DWORD cbReturned;
	CONFIG_WRITE cfgWrite;
	cfgWrite.bReg = bReg;
	cfgWrite.bData = bValue;


	Status = DeviceIoControl( hPortHandle,(DWORD) IOCTL_XRPORT_WRITE_CONFIG_REG,&cfgWrite,sizeof(CONFIG_WRITE),NULL,0,&cbReturned,0);
	if(!Status)
	{ 
		printf("Error in Writing...!", "Error", MB_OK|MB_ICONERROR); 
		return -1;
	}
	#endif

	#ifdef LINUX
	input.reg =  bReg;
	input.regvalue = bValue;
	error=ioctl(fd, EXAR_WRITE_REG, &input);
	if(error <0)
	{

			printf("Error: Driver Write call Failed. Press Enter to continue:");

		if(getchar() == '\n')
		return -1;
	   
	}
	#endif
	return 0;
}
void DSCUDAPICALL DSE_MPE_SER4M_CLOSE()
{
	CloseHandle(hPortHandle);
}

void sort(int *number,int size)
{
	int i = 0,j= 0,a=0;
		for (i = 0; i < size; ++i)
		{
			for (j = i + 1; j < size; ++j)
			{
				if (number[i] > number[j])
				{
					a =  number[i];
					number[i] = number[j];
					number[j] = a;
				}
			}
		}
}

int Find_first_EXAR_port()
{
     HKEY hKey;
     LONG lResult;
	 char value[20]={0};
     DWORD dwSize = sizeof(value);
	 char temp[2] = {0};
	 DWORD type; 

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, POLICY_KEY, 0, KEY_READ, &hKey);

	if(lResult == ERROR_SUCCESS)
    {
		dwSize = sizeof(value);
       	lResult = RegQueryValueEx(hKey, lpValueName1, 0,&type,(BYTE*)value, &dwSize);
		if(lResult == ERROR_SUCCESS)
		{
			sprintf(temp,"%c%c",value[6],value[8]);
			sscanf(temp,"%d",&COM[0]);
			
		}
		else
		{
			
			return -1;
		}
		dwSize = sizeof(value);
		lResult = RegQueryValueEx(hKey, lpValueName2, 0,&type,(BYTE*)value, &dwSize);
		if(lResult == ERROR_SUCCESS)
		{
			sprintf(temp,"%c%c",value[6],value[8]);
			sscanf(temp,"%d",&COM[1]);
			
		}
		else
		{
			return -1;
		}
		dwSize = sizeof(value);
		
		lResult = RegQueryValueEx(hKey, lpValueName3, 0,&type,(BYTE*)value, &dwSize);
		if(lResult == ERROR_SUCCESS)
		{
			sprintf(temp,"%c%c",value[6],value[8]);
			sscanf(temp,"%d",&COM[2]);
			
		}
		else
		{
			return -1;
		}
		dwSize = sizeof(value);
		lResult = RegQueryValueEx(hKey, lpValueName4, 0,&type,(BYTE*)value, &dwSize);
		if(lResult == ERROR_SUCCESS)
		{
			sprintf(temp,"%c%c",value[6],value[8]);
			sscanf(temp,"%d",&COM[3]);
			
		}
		else
		{
			return -1;
		}
		

		sort(COM,4);

        RegCloseKey(hKey);
    }
	else
	{
		return -1;
	}
    
   	return 0;
}
